stacklimit = 16

i2lo = 10
i2hi = 11
j2lo = 12
j2hi = 13
x_lo = 14
x_mi = 22
x_hi = 15
mid2lo = 16
mid2hi = 17
ublo = 18
ubhi = 19
lblo = 20
lbhi = 21
;ublo = qsstore
;ubhi = qsstore+1
;lblo = qsstore+2
;lbhi = qsstore+3

;qsstore .byte 0,0,0,0

quicksort sta datahi+1
          lda param
          sta datalo+1
          stx szlo+1
          sty szhi+1
          tsx
          stx qs_csp+1
qs_csp    ldx #0
          txs
szhi      lda #>0
          sta ubhi
szlo      lda #<0
          sta ublo
datahi    lda #>0
          sta lbhi
datalo    lda #<0
          sta lblo
          quicksort0
          tsx
          cpx #stacklimit
          bcc qs_csp

qsok      lda lblo    ;it is better for speed to have this at a page start
          sta i2lo
          lda lbhi
          sta i2hi
          ldy ubhi
          sty j2hi
          lda ublo
          sta j2lo
          clc        ;this code works only for the align multiple of ESZ for data
          adc i2lo
          and #$f0
          ;ora #evenness  ;if we want any alignment
          sta mid2lo
          tya
          adc i2hi
          ror
          sta mid2hi
          ror mid2lo

          ldy #2
          lda (mid2lo),y
          sta x_hi
          dey
          lda (mid2lo),y
          sta x_mi
          dey
          lda (mid2lo),y
          sta x_lo
qsloop1   ldy #2     ;compare array[i] and x
          lda (i2lo),y
          cmp x_hi
          dey
          lda (i2lo),y
          sbc x_mi
          dey
          lda (i2lo),y
          sbc x_lo
          bcs qs_l1

          lda #ESZ
          adc i2lo
          sta i2lo
          bcc qsloop1

          inc i2hi
          bne qsloop1 ;=jmp

qs_l1     ldy #2    ;compare array[j] and x
          lda x_hi
          cmp (j2lo),y
          dey
          lda x_mi
          sbc (j2lo),y
          dey
          lda x_lo
          sbc (j2lo),y
          bcs qs_l3

          lda j2lo
          sbc #ESZ-1
          sta j2lo
          bcs qs_l1

          dec j2hi
          bne qs_l1 ;=jmp

qs_l3     lda j2lo    ;compare i and j
          cmp i2lo
          lda j2hi
          sbc i2hi
          bcc qs_l8

qs_l6     ldy #7      ;exchange elements with i and j indices
cploop    lda (j2lo),y
          tax
          lda (i2lo),y
          sta (j2lo),y
          txa
          sta (i2lo),y
          dey
          bpl cploop

          ;sec
          lda #ESZ-1        ;CY=1
          adc i2lo
          sta i2lo
          bcc *+4
          inc i2hi
          sec
          lda j2lo
          sbc #ESZ
          sta j2lo
          bcs *+4
          dec j2hi
          ;lda j2lo
          cmp i2lo
          lda j2hi
          sbc i2hi
          ;bcc *+5
          ;jmp qsloop1
          bcs qsloop1

qs_l8     lda lblo
          cmp j2lo
          lda lbhi
          sbc j2hi
          bcs qs_l5

          lda i2hi
          pha
          lda i2lo
          pha
          lda ubhi
          pha
          lda ublo
          pha
          lda j2hi
          sta ubhi
          lda j2lo
          sta ublo
          jsr quicksort0
          pla
          sta ublo
          pla
          sta ubhi
          pla
          sta i2lo
          pla
          sta i2hi
qs_l5     lda i2lo
          cmp ublo
          lda i2hi
          sbc ubhi
          bcs qs_l7

          lda i2hi
          sta lbhi
          lda i2lo
          sta lblo
          jmp qsok
qs_l7     rts

